<?php
/* Utilitaire pour retrouver les cat/ link et keywords
*/
function bbr_get_bookmark_arr(){
	$catArr=array();
	$cats = get_terms('link_category');
	foreach ( (array) $cats as $cat ) {
		$catName=$cat->name;
		$catArr[$catName]= get_bookmarks(array('category'=>$cat->term_id));	
	}
	return $catArr;
}
function bbr_get_bookmark_tag_arr(){
	$catArr=array();
	$cats = get_terms('link_category');
	foreach ( (array) $cats as $cat ) {
		$catName=$cat->name;
		$catArr[$catName]= $cat->term_id;	
	}
	return $catArr;
}
function bbr_get_category_arr(){
	return get_categories();
}
function bbr_get_page_arr(){
	$catArr=array();
	$cats = get_pages();
	foreach ( (array) $cats as $cat ) {
		$catName=$cat->post_title;
		$link = get_page_link( intval($cat->ID));
		$catArr[]=Array("id"=>$cat->ID, "link"=>$link, "name"=>$catName);
	}
	return $catArr;
}
function bbr_get_keywords_arr(){
	$tags = get_terms('post_tag');
	$keyArr=array();
	foreach ( $tags as $key => $tag ) {
		$link = get_term_link( intval($tag->term_id), $tag->taxonomy );
		$keyArr[$tag->name]=array("link"=>$link, "id"=>$tag->term_id);	
	}
	return $keyArr;
}

function bbr_init_single_widget_options($options){
	$options['width'] = (isset($options['width']))?$options['width']:'300';
	$options['height'] = (isset($options['height']))?$options['height']:'300';
	$options['ringSize'] = (isset($options['ringSize']))?$options['ringSize']:15;
	$options['firstRingSize']= (isset($options['firstRingSize']))?$options['firstRingSize']:20;
	$options['displayLink']=(isset($options['displayLink']))?$options['displayLink']:true;
	$options['displayLinkTag']=(isset($options['displayLinkTag']))?$options['displayLinkTag']:true;
	$options['displayCat']=(isset($options['displayCat']))?$options['displayCat']:false;
	$options['displayKeyWord']=(isset($options['displayKeyWord']))?$options['displayKeyWord']:false;
	$options['displayPage']=(isset($options['displayPage']))?$options['displayPage']:false;
	$options['transparent']=(isset($options['transparent']))?$options['transparent']:true;
	$options['bgColor']=(isset($options['bgColor']))?$options['bgColor']:"CCCCCC";
	$options['txtOffColor']=(isset($options['txtOffColor']))?$options['txtOffColor']:"CCCCCC";
	$options['txtOnColor']=(isset($options['txtOnColor']))?$options['txtOnColor']:"FFFFFF";
	$options['overGlowColor']=(isset($options['overGlowColor']))?$options['overGlowColor']:"FFFFFF";
	$options['deltaRing']=(isset($options['deltaRing']))?$options['deltaRing']:2;
	$options['RingCrop']=(isset($options['RingCrop']))?$options['RingCrop']:"FIT";
	$options['startAlign']=(isset($options['startAlign']))?$options['startAlign']:"DECAL";
	$options['startAngle']=(isset($options['startAngle']))?$options['startAngle']:0;
	$options['decalAngle']=(isset($options['decalAngle']))?$options['decalAngle']:0;
	$options['textAlign']=(isset($options['textAlign']))?$options['textAlign']:0;
	return $options;

}

function bbr_init_options($options){	
	
	$options['bbr_currLang']=(isset($options['bbr_currLang']))?$options['bbr_currLang']:"En";
	$options['link_dest']=(isset($options['link_dest']))?$options['link_dest']:"_blank";
	$options['cat_dest']=(isset($options['cat_dest']))?$options['cat_dest']:"_self";
	$options['tag_dest']=(isset($options['tag_dest']))?$options['tag_dest']:"_self";
	$options['page_dest']=(isset($options['page_dest']))?$options['page_dest']:"_self";
	$options['display']=(isset($options['display']))?$options['display']:"bbr_link_table";
	
	// init des couleur
	//les liens
	$defaultColor="00CCFF";
	$cats = bbr_get_bookmark_arr();
	foreach (  $cats as $catName=>$bookmarks ) {
		  foreach($bookmarks as $bm){
			  $catId="link_id_".$bm->link_id;
			  $options[$catId]=(isset($options[$catId]))?$options[$catId]:$defaultColor;
			}		  
	 	 }
	$cats=bbr_get_category_arr();
	foreach($cats as $cat){
		$catId="cat_id_".$cat->term_id;
		 $options[$catId]=(isset($options[$catId]))?$options[$catId]:$defaultColor;
	}
	$cats=bbr_get_keywords_arr();
	foreach ( $cats as $key => $tag ) {
		$catId="tag_id_".$tag["id"];
		$options[$catId]=(isset($options[$catId]))?$options[$catId]:$defaultColor;		
	}
	$cats =  bbr_get_bookmark_tag_arr();
	foreach (  $cats as $catName=>$catIDs ) {
		$catId="link_cat_id_".$catIDs;
		$options[$catId]=(isset($options[$catId]))?$options[$catId]:$defaultColor;
	}
	$cats=bbr_get_page_arr();
	foreach ( $cats as  $tag ) {
		$catId="page_id_".$tag["id"];
		$options[$catId]=(isset($options[$catId]))?$options[$catId]:$defaultColor;		
	}
	return $options;
	
	
}

function bbr_get_default_id($curValue, $type){
	if(function_exists('icl_object_id')){
		$options=get_option('bbr_options');
		$curValue=icl_object_id($curValue, $type, true, $options['bbr_currLang']);		
	}
	return $curValue;	
}

// construction du xml de retour
function bbr_getXML_String($displays){
	$options=get_option('bbr_options');
	$options= bbr_init_options($options);
	$xmlStr="<DATA>";
	// si des liens
	if($displays['displayLink']){	
		$cats = bbr_get_bookmark_arr();
		$catsId=bbr_get_bookmark_tag_arr();
		foreach (  $cats as $catName=>$bookmarks ) {
			$catStr=($displays['displayLinkTag'])?'cat="'.$catName.'" catColor="'.$options["link_cat_id_".$catsId[$catName]].'" ':' ';
		  foreach($bookmarks as $bm){
			   $xmlStr.='<ring type="link" '.$catStr.' url="'.$bm->link_url.'" color="'.$options["link_id_".$bm->link_id].'">'.$bm->link_name.'</ring>';
			}		  
	 	 }		 	
	}	
	// si catégory	
	if($displays['displayCat']){
		$cats =bbr_get_category_arr();
		foreach($cats  as $cat) { 
		$idCurr=bbr_get_default_id($cat->term_id, 'category');
			 $xmlStr.='<ring type="cat" color="'.$options["cat_id_".$idCurr].'" url="'.get_category_link($idCurr).'" count="'.$cat->count.'">'.$cat->name.'</ring>';
		} 	
	}
	// si tag
	if($displays['displayKeyWord']){
		$tags = bbr_get_keywords_arr();
		foreach ( $tags as $key => $tag ) {	
		$idCurr=bbr_get_default_id($tag["id"], 'post_tag');
			$xmlStr.='<ring type="keyword" color="'.$options["tag_id_".$idCurr].'" url="'.$tag["link"].'">'.$key.'</ring>';	
		}
	}	
	// si page
	if($displays['displayPage']){
		$tags = bbr_get_page_arr();
		foreach ( $tags as $tag ) {	
		$idCurr=bbr_get_default_id($tag["id"], 'page');
			$xmlStr.='<ring type="page" color="'.$options["page_id_".$idCurr].'" url="'.$tag["link"].'">'.$tag["name"].'</ring>';	
		}
	}	
	// on fini
	$xmlStr.="</DATA>";
	return urlencode($xmlStr);
}


?>